--- build/common.gypi
+++ build/common.gypi
@@ -38,12 +38,12 @@
       # Compute the architecture that we're building for. Default to the
       # architecture that we're building on.
       'conditions': [
-        [ 'OS=="linux"', {
+        [ 'OS=="linux" or OS=="freebsd"', {
           # This handles the Linux platforms we generally deal with. Anything
           # else gets passed through, which probably won't work very well; such
           # hosts should pass an explicit target_arch to gyp.
           'target_arch%':
-            '<!(uname -m | sed -e "s/i.86/ia32/;s/x86_64/x64/;s/arm.*/arm/")',
+            '<!(uname -m | sed -e "s/i.86/ia32/;s/amd64/x64/;s/arm.*/arm/")',
 
         }, {  # OS!="linux"
           'target_arch%': 'ia32',
@@ -189,13 +189,13 @@
 
     # Used to disable Native Client at compile time, for platforms where it
     # isn't supported
-    'disable_nacl%': 0,
+    'disable_nacl%': 1,
 
     # Set ARM-v7 compilation flags
     'armv7%': 0,
 
     'conditions': [
-      ['OS=="linux"', {
+      ['OS=="linux" or OS=="freebsd"', {
         # This will set gcc_version to XY if you are running gcc X.Y.*.
         # This is used to tweak build flags for gcc 4.4.
         'gcc_version%': '<!(python <(DEPTH)/build/compiler_version.py)',
@@ -489,12 +489,12 @@
     },
   },
   'conditions': [
-    ['OS=="linux"', {
+    ['OS=="linux" or OS=="freebsd"', {
       'target_defaults': {
         # Enable -Werror by default, but put it in a variable so it can
         # be disabled in ~/.gyp/include.gypi on the valgrind builders.
         'variables': {
-          'werror%': '-Werror',
+          'werror%': '',#'-Werror',
           'no_strict_aliasing%': 0,
         },
         'cflags': [
@@ -727,6 +727,14 @@
         ],
       },
     }],
+    # Note that most FreeBSD options are set above, with Linux
+    ['OS=="freebsd"', {
+      'target_defaults': {
+        'ldflags': [
+          '-Wl,--no-keep-memory',
+        ],
+      },
+    }],
     ['OS=="mac"', {
       'target_defaults': {
         'variables': {
diff --git build/external_code.gypi build/external_code.gypi
index ca10726..deceeb9 100644
